/*
 * @(#)PDFSec.java 1.0 2007/04/02
 *
 * Copyright 2002-2007 by BrainSellers.com Corp.
 * All rights reserved.
 *
 */
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;

import com.brainsellers.xml.JaxpXML;
import com.brainsellers.xml.common.XMLSuper;

/**
 * TvvO10FPDF̃ZLeBݒsTv
 */

public class PDFSec {

    public static void main(String[] args) {
        new PDFSec(args);
        System.exit(0);
    }

    public PDFSec(String[] args) {
        try {

            // CAEgt@C
            String layout = "${base-dir}/sample/java/sample1.xml";
            // CAEgiXMLjɓnf[^̃Zbgs
            // ("CAEgiXMLjNameŎw肳ꂽO","f[^e")Zbg
            Hashtable ht = new Hashtable();
            ht.put("company", "uCZ[YEhbgR");
            ht.put("address", "scikXX-XX-XX");
            ht.put("phone", "TEL.XX-XXXX-XXXX");
            ht.put("fax", "FAX.XX-XXXX-XXXX");

            XMLSuper xml = null;

            /*
             * 1) ÍxAcrobat3.0ȏ/40bit-RC4PDFt@C쐬
             */
            // 1-1) o͂Ƀt@Cw肷
            xml = new JaxpXML(layout, "PDFSec-1.pdf");

            // 1-2)CAEg(XML)̉͂s
            xml.parse();
            // 1-3) <Layout>^O̕ƍŃTCYƂĎgp
            xml.setPageSize();
            // 1-4) Íx: 40bit RC4
            xml.setEncryptionLevel(40);
            // 1-5) Jۂ̃pX[h: uuserv
            xml.setUserPassword("user");
            // 1-6) pX[h: umasterv
            xml.setOwnerPassword("master");
            // 1-7) ̋
            xml.setPrintPermission(false);
            // 1-8) ύX̋
            xml.setChangePermission(false);
            // 1-9) ẽRs[⒊őƃANZVreB̐
            xml.setCopyPermission(false);
            // 1-10) ߂tH[tB[h̒ǉEύX̋
            xml.setNotesPermission(false);

            // 1-11) f[^̃ZbgэWvZsAPDF𐶐
            xml.toPDF(ht);
            // 1-12)PDF̏o͂s
            xml.close();

            /*
             * 2) ÍxAcrobat5.0ȏ/128bit-RC4PDFt@C pX[hɂ쐬
             */
            // 2-1) o͂Ƀt@Cw肷
            xml = new JaxpXML(layout, "PDFSec-2.pdf");

            // 2-2)CAEg(XML)̉͂s
            xml.parse();
            // 2-3) <Layout>^O̕ƍŃTCYƂĎgp
            xml.setPageSize();
            // 2-4) Íx: 128-bit RC4
            xml.setEncryptionLevel(128);
            // 2-5) Jۂ̃pX[h: uuserv
            xml.setUserPassword("user");
            // 2-6) pX[h: umasterv
            xml.setOwnerPassword("master");
            // 2-7) ANZVreB̐ݒ
            xml.setAccessibility(false);
            // 2-8) ̋
            // p^ɂݒ: 𑜓x
            xml.setPrintPermission(true, false);
            // 𑜓x
            // xml.setPrintFullyAllowed();
            // 𑜓x
            // xml.setPrintLowResolution();
            // s
            // xml.setPrintNotAllowed();
            // 2-9) ύX̋
            // uߍ쐬AtH[tB[h̓͂܂͏vƓ
            // xml.setChangeCommentFillinSigning();
            // uAZû݁vƓ
            // xml.setChangeOnlyAssembly();
            // utH[tB[h̓͂܂͏̂݁vƓ
            // xml.setChangeOnlyFillinSigning();
            // uȂvƓ
            // xml.setChangeNone();
            // uҏWAߋyуtH[tB[h̍쐬vƓ
            xml.setChangeEditingCommentFieldAuthoring();

            // 2-10) f[^̃ZbgэWvZsAPDF𐶐
            xml.toPDF(ht);
            // 2-11)PDF̏o͂s
            xml.close();

            /*
             * 3) ÍxAcrobat5.0ȏ/128bit-RC4PDFt@C ؖɂ쐬
             */
            // 3-1) o͂Ƀt@Cw肷
            xml = new JaxpXML(layout, "PDFSec-3.pdf");

            // 3-2)CAEg(XML)̉͂s
            xml.parse();
            // 3-3) <Layout>^O̕ƍŃTCYƂĎgp
            xml.setPageSize();
            // 3-4) Íx: 128-bit RC4
            xml.setEncryptionLevel(128);
            // 3-5) }X^[ؖ̐ݒ
            xml.appendFullRecipient("someone.cer");
            // 3-6) [Uؖ̐ݒ
            xml.appendUserRecipient("otherone.cer");
            // 3-7) ؖ̔f
            xml.setRecipients();
            // 3-8) ANZVreB̐ݒ
            xml.setAccessibility(true);
            // 3-9) ̋
            // p^ɂݒ: s
            xml.setPrintPermission(false, false);
            // 𑜓x
            // xml.setPrintFullyAllowed();
            // 𑜓x
            // xml.setPrintLowResolution();
            // s
            // xml.setPrintNotAllowed();
            // 3-10) ύX̋
            // uߍ쐬AtH[tB[h̓͂܂͏vƓ
            // xml.setChangeCommentFillinSigning();
            // uAZû݁vƓ
            xml.setChangeOnlyAssembly();
            // utH[tB[h̓͂܂͏̂݁vƓ
            // xml.setChangeOnlyFillinSigning();
            // uȂvƓ
            // xml.setChangeNone();
            // uҏWAߋyуtH[tB[h̍쐬vƓ
            // xml.setChangeEditingCommentFieldAuthoring();

            // 3-11) f[^̃ZbgэWvZsAPDF𐶐
            xml.toPDF(ht);
            // 3-12)PDF̏o͂s
            xml.close();

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
